/*
Copyright  1990 Ari I. Halberstadt

This file is part of a free program. For precise terms of distribution
and use please see the files in the folder Legal accompanying this
software. If you make any modifications to this file you must add the
date, your name, and a description of what you have done to the
revision history below. This notice and the copyright notice must
remain intact in all copies of this file. The files in the folder
Legal must be available to anyone receiving copies of this file.

Add initials and name here:
Initials	Name
AIH		Ari I. Halberstadt

Revision History (date format is mm-dd-yy):
Date      Name  Comments
07-11-90	 AIH   Version 0.9
*/

/*
	Functions for comparing list items containing strings.
*/

#include <MyHeaders>
#include "itemutil.h"
#include "strlib.h"
#include "strlistlib.h"

/*--------------------------------------------------------------------*/
/* String and item comparison
/*--------------------------------------------------------------------*/

int compareitems(ListItem *item1, ListItem *item2)
{
	return(strcmp(**item1, **item2));
}

int icompareitems(ListItem *item1, ListItem *item2)
{
	return(stricmp(**item1, **item2));
}

int iorderitems(ListItem *item1, ListItem *item2)
{
	return(striorder(**item1, **item2));
}

int IUcompareitems(ListItem *item1, ListItem *item2)
{
	int cmp;
	HandleKey key1, key2;
	
	key1 = hlock(*item1, false);
	key2 = hlock(*item2, false);
	cmp = IUstrcmp(**item1, **item2);
	hunlock(*item1, key1);
	hunlock(*item2, key2);
	return(cmp);
}

int IUorderitems(ListItem *item1, ListItem *item2)
{
	int cmp;
	HandleKey key1, key2;
	
	key1 = hlock(*item1, false);
	key2 = hlock(*item2, false);
	cmp = IUstrorder(**item1, **item2);
	hunlock(*item1, key1);
	hunlock(*item2, key2);
	return(cmp);
}

int numcmpitems(ListItem *item1, ListItem *item2)
{
	return(floatstrcmp(**item1, **item2));
}

int numorderitems(ListItem *item1, ListItem *item2)
{
	return(floatstrorder(**item1, **item2));
}
