/*
Copyright  1990 Ari I. Halberstadt

This file is part of a free program. For precise terms of distribution
and use please see the files in the folder Legal accompanying this
software. If you make any modifications to this file you must add the
date, your name, and a description of what you have done to the
revision history below. This notice and the copyright notice must
remain intact in all copies of this file. The files in the folder
Legal must be available to anyone receiving copies of this file.

Add initials and name here:
Initials	Name
AIH		Ari I. Halberstadt

Revision History (date format is mm-dd-yy):
Date      Name  Comments
07-11-90	 AIH   Version 0.9
*/

#ifndef _H_str_tprivate
#define _H_str_tprivate

#ifndef _H_str_treelib
#include "strtreelib.h"
#endif

/*
	These are declarations which of things used internally by
	the strtree library.
*/

#define DFLT_SEPARATOR	',' /* default separator for output items */

/*
	Macro's that make it easier to access fields of a strtree.
	Since these are macros, you may sometimes see things like
		getcmptype(strtree) = value;
	While this is confusing, it does have its merits: since
	the Macintosh uses handles, you'd have to write
		(**strtree).cmptype = value;
	But this means that if the program is ported to a normal system
	which doesn't use handles, then it will be slightly more
	difficult to change such statments.
 */
 
#define gettree(strtree)		((**(strtree)).tree)
#define getcmptype(strtree)	((**(strtree)).cmptype)
#define uniq(strtree)			((**(strtree)).unique)

/* name equivalents for private functions */
#define str_tvalid		_str_tvalid
#define str_tvalidkey	_str_tvalidkey
#define str_tinitbuf		_str_tinitbuf
#define str_tendbuf		_str_tendbuf
#define str_toutputstr	_str_toutputstr
#define str_toutputptr	_str_toutputptr

/* Data structure describing the output buffer used by the string tree.
	See the comments for "str_tbuf.c", which explain how the output
	buffer is used.
*/
typedef struct {
	OutputBuffer buf;	/* buffer for building output strings */
	char separator;	/* separator for outputing multiple items */
} StrTreeBufType;
 
Boolean	str_tvalid(StrTreeType strtree);
Boolean	str_tvalidkey(String key);

OSErr str_tinitbuf(StrTreeBufType *stbuf, char separator);
OSErr str_tendbuf(StrTreeBufType *stbuf, String *output);
OSErr str_toutputstr(StrTreeBufType *stbuf, String str);
OSErr str_toutputptr(StrTreeBufType *stbuf, char *str);

#endif
