/*
Copyright  1990 Ari I. Halberstadt

This file is part of a free program. For precise terms of distribution
and use please see the files in the folder Legal accompanying this
software. If you make any modifications to this file you must add the
date, your name, and a description of what you have done to the
revision history below. This notice and the copyright notice must
remain intact in all copies of this file. The files in the folder
Legal must be available to anyone receiving copies of this file.

Add initials and name here:
Initials	Name
AIH		Ari I. Halberstadt

Revision History (date format is mm-dd-yy):
Date      Name  Comments
07-11-90	 AIH   Version 0.9
*/

#ifndef _H_lookupTABL
#define _H_lookupTABL

#ifndef _H_mystdlib
#include "mystdlib.h"
#endif

/*
Functions used to lookup strings in a table resource. The
table resource is built using the buildtabl library.
The functions are:
	hlookupTabl		Searches for a string in the table, and returns
						the string number if found, or 0 by default.
	lookupTablStr	Same as hlookupTabl but takes a pointer to string
						instead of a handle to a string.
	lookupTablNum	Searches for the string with the given number,
						and returns the string if found (if not found
						then the string is empty).
*/
		
OSErr	hlookupTabl(ResID id, String str, short *index);
OSErr lookupTablStr(ResID id, char *str, short *number);
OSErr lookupTablNum(ResID id, short num, char *str);

#endif
