/*
Copyright  1990 Ari I. Halberstadt

This file is part of a free program. For precise terms of distribution
and use please see the files in the folder Legal accompanying this
software. If you make any modifications to this file you must add the
date, your name, and a description of what you have done to the
revision history below. This notice and the copyright notice must
remain intact in all copies of this file. The files in the folder
Legal must be available to anyone receiving copies of this file.

Add initials and name here:
Initials	Name
AIH		Ari I. Halberstadt

Revision History (date format is mm-dd-yy):
Date      Name  Comments
07-11-90	 AIH   Version 0.9
*/

/*
	Functions for changing resources.
*/

#include <MyHeaders>
#include "rsrclib.h"

/* add the resource */
OSErr rsrc_add(Handle rsrc, ResType type, ResID id, char *name, ResAttr attr)
{
	OSErr err;
	CStr255 str;
	
	err = rsrc_remove(type, id);
	if (err && err != resNotFound)
		return(err);
	AddResource(rsrc, type, id, CtoPstr(strcpy(str, name)));
	if (ResError())
		return(ResError());
	WriteResource(rsrc);
	if (ResError())
		return(ResError());
	SetResAttrs(rsrc, attr);
	return(noErr);
}

/* remove the resource */
OSErr rsrc_remove(ResType type, ResID id)
{
	short load;
	Handle rsrc;
	OSErr err;

	load = ResLoad;
	SetResLoad(false);
	rsrc = GetResource(type, id);
	err = ResError();
	SetResLoad(load);
	if (! err) {
		if (! rsrc)
			err = resNotFound;
		else {
			RmveResource(rsrc);
			err = ResError();
			if (! err)
				DisposHandle(rsrc);
		}
	}
	return(err);
}
