/*
Copyright  1990 Ari I. Halberstadt

This file is part of a free program. For precise terms of distribution
and use please see the files in the folder Legal accompanying this
software. If you make any modifications to this file you must add the
date, your name, and a description of what you have done to the
revision history below. This notice and the copyright notice must
remain intact in all copies of this file. The files in the folder
Legal must be available to anyone receiving copies of this file.

Add initials and name here:
Initials	Name
AIH		Ari I. Halberstadt

Revision History (date format is mm-dd-yy):
Date      Name  Comments
07-11-90	 AIH   Version 0.9
*/

/*
	Insertion sort.
*/

#include <MyHeaders>
#include "sortlib.h"

#define get(i)	((void*) ((char*)base + size * (i)))

static void _insort(void *base, size_t nmemb, size_t size,
							FPTR compar, VFPTR swap);

void insort(void *base, size_t nmemb, size_t size, FPTR compar)
{
	_insort(base, nmemb, size, compar, getswap(size));
}

static void _insort(register void *base,
						register size_t nmemb,
						register size_t size,
						register FPTR compar,
						register VFPTR swap)
{
	register	size_t i, j;
	
	for (i = 1; i < nmemb; i++)
		for (j = i; j > 0 && compar(get(j), get(j-1)) < 0; j--)
			swap(size, get(j), get(j-1));
}