/*
Copyright  1990 Ari I. Halberstadt

This file is part of a free program. For precise terms of distribution
and use please see the files in the folder Legal accompanying this
software. If you make any modifications to this file you must add the
date, your name, and a description of what you have done to the
revision history below. This notice and the copyright notice must
remain intact in all copies of this file. The files in the folder
Legal must be available to anyone receiving copies of this file.

Add initials and name here:
Initials	Name
AIH		Ari I. Halberstadt

Revision History (date format is mm-dd-yy):
Date      Name  Comments
07-11-90	 AIH   Version 0.9
*/

/*
	Data swapping functions. Equivalent functions in assembly
	are in "swapasm.c".
*/

#include <MyHeaders>
#include "sortlib.h"

/* return swap function appropriate for given size */
VFPTR getswap(size_t size)
{
	if ((size % sizeof(long)) == 0)
		return(swap_long);
	else if ((size % sizeof(short)) == 0)
		return(swap_short);
	return(swap_char);
}
	
#if ! ASSEMBLY

void swap_char(register size_t size, register char *a, register char *b)
{
	register char tmp;
	while (size-- > 0) {
		tmp = *a;
		*a++ = *b;
		*b++ = tmp;
	}
}

void swap_short(register size_t size, register short *a, register short *b)
{
	register long tmp;
	while (size > 0) {
		tmp = *a;
		*a++ = *b;
		*b++ = tmp;
		size -= sizeof(short);
	}
}

void swap_long(register size_t size, register long *a, register long *b)
{
	register long tmp;
	while (size > 0) {
		tmp = *a;
		*a++ = *b;
		*b++ = tmp;
		size -= sizeof(long);
	}
}
#endif /* ! ASSEMBLY */
