/*
Copyright  1990 Ari I. Halberstadt

This file is part of a free program. For precise terms of distribution
and use please see the files in the folder Legal accompanying this
software. If you make any modifications to this file you must add the
date, your name, and a description of what you have done to the
revision history below. This notice and the copyright notice must
remain intact in all copies of this file. The files in the folder
Legal must be available to anyone receiving copies of this file.

Add initials and name here:
Initials	Name
AIH		Ari I. Halberstadt

Revision History (date format is mm-dd-yy):
Date      Name  Comments
07-11-90	 AIH   Version 0.9
*/

/*
	Assembly language functions for swapping data. Equivalent
	C functions are in "swap.c". Don't compile with the profile
	option, since the compiler inserts a stack frame in to each
	function.
	
*/

#include <MyHeaders>
#include "mystdlib.h"

#if ASSEMBLY

void swap_char(void);
void swap_short(void);
void swap_long(void);

void swap_char(/*size_t size, char *a, char *b*/)
{
	asm {
		movem.l	4(a7), d0/a0-a1
	@1:move.b	(a0), d1
		move.b	(a1), (a0)+
		move.b	d1, (a1)+
		subq.l	#1, d0
		bne.s		@1
	}
}

void swap_short(/*size_t size, short *a, short *b*/)
{
	asm {
		movem.l	4(a7), d0/a0-a1
	@1:move.w	(a0), d1
		move.w	(a1), (a0)+
		move.w	d1, (a1)+
		subq.l	#2, d0
		bne.s		@1
	}
}

void swap_long(/*size_t size, long *a, long *b*/)
{
	asm {
		movem.l	4(a7), d0/a0-a1
	@1:move.l	(a0), d1
		move.l	(a1), (a0)+
		move.l	d1, (a1)+
		subq.l	#4, d0
		bne.s		@1
	}
}

#endif