/*
Copyright  1990 Ari I. Halberstadt

This file is part of a free program. For precise terms of distribution
and use please see the files in the folder Legal accompanying this
software. If you make any modifications to this file you must add the
date, your name, and a description of what you have done to the
revision history below. This notice and the copyright notice must
remain intact in all copies of this file. The files in the folder
Legal must be available to anyone receiving copies of this file.

Add initials and name here:
Initials	Name
AIH		Ari I. Halberstadt

Revision History (date format is mm-dd-yy):
Date      Name  Comments
07-11-90	 AIH   Version 0.9
*/

/*
	Yet another version of the assert function. This one will
	execute the debugger trap before aborting. It should abort
	properly even if the program is compiled as a code resource
	(it aborts by calling codersrc_abort).
*/

#include <MyHeaders>
#include "mystdlib.h"
#include "strlib.h"
#include "console.h"
#include "codelib.h"

#if ASSERTIONS
void myassert(char *expr, char *file, int lnum)
{
	CStr255	str;
	CStr31	numstr;
	
#if ANSI
	cshow(stderr);
	cshow(stdout);
	fprintf(stderr, "\nAssert failed: %s, file %s, line %d\n", expr, file, lnum);
	fflush(stdout);
	fflush(stderr);
	Debugger();
	abort();
#else
	strcpy(str, "");
	strcat(str, expr);
	strcat(str, "; ");
	strcat(str, file);
	strcat(str, "; ");
	strcat(str, ltoa(lnum, numstr));
	DebugStr(CtoPstr(str));
	#if CODE_RESOURCE
		codersrc_abort();
	#endif
#endif /* ANSI */
}
#endif /* ASSERTIONS */