/*
Copyright  1990 Ari I. Halberstadt

This file is part of a free program. For precise terms of distribution
and use please see the files in the folder Legal accompanying this
software. If you make any modifications to this file you must add the
date, your name, and a description of what you have done to the
revision history below. This notice and the copyright notice must
remain intact in all copies of this file. The files in the folder
Legal must be available to anyone receiving copies of this file.

Add initials and name here:
Initials	Name
AIH		Ari I. Halberstadt

Revision History (date format is mm-dd-yy):
Date      Name  Comments
07-11-90	 AIH   Version 0.9
*/

/*
	Functions for manipulating handles in a more convenient
	manner than the ToolBox.
*/

#include <MyHeaders>
#include "mystdlib.h"

#if ! (ASSEMBLY)

HandleKey hlock(Handle hndl, Boolean move)
{
	HandleKey key;
	
	assert(validhandle(hndl));
	if (move)
		MoveHHi(hndl);
	key = HGetState(hndl);
	HLock(hndl);
	return(key);
}

void hunlock(Handle hndl, HandleKey key)
{
	assert(validhandle(hndl));
	HSetState(hndl, key);
}

#endif /* ! (ASSEMBLY) */

#if ASSEMBLY

HandleKey hlock(Handle hndl, Boolean move)
{
	HandleKey key;
	
	assert(validhandle(hndl));

	if (move) {
		asm {
			move.l hndl, a0	
			_MoveHHi
		}
	}
	asm {
		move.l hndl, a0
		_HGetState
		move.b d0, key
		move.l hndl, a0	
		_HLock
	}
	return(key);
}

void hunlock(Handle hndl, HandleKey key)
{
	assert(validhandle(hndl));
	asm {
		move.l hndl, a0
		move.b key, d0
		_HSetState
	}
}

#endif /* ASSEMBLY */
