/*
Copyright  1990 Ari I. Halberstadt

This file is part of a free program. For precise terms of distribution
and use please see the files in the folder Legal accompanying this
software. If you make any modifications to this file you must add the
date, your name, and a description of what you have done to the
revision history below. This notice and the copyright notice must
remain intact in all copies of this file. The files in the folder
Legal must be available to anyone receiving copies of this file.

Add initials and name here:
Initials	Name
AIH		Ari I. Halberstadt

Revision History (date format is mm-dd-yy):
Date      Name  Comments
07-11-90	 AIH   Version 0.9
*/

/*
	Definitions common to all files, including some basic type definitions
	and macros.
*/


#ifndef _H_mystdlib
#define _H_mystdlib

#ifndef _H_stdconfig
#include "stdconfig.h"
#endif

#if THINK_C
#define const
#endif

typedef short		ResID;
typedef short		ResAttr;
typedef short		FileRef;
typedef StringPtr	StrPtr;
typedef Handle		String;
typedef long		StrIndex; /* must be a signed type */
typedef char		CStr255[256];
typedef char		CStr31[32];
typedef int			(*FPTR)();
typedef void		(*VFPTR)();
typedef unsigned char	uchar;
typedef unsigned short	ushort;
typedef unsigned int		uint;
typedef unsigned long	ulong;
typedef SignedByte		HandleKey;

char *PtoCstr(char *);
char *CtoPstr(char *);

#define halloc(size)				NewHandle(size)
#define hfree(mem)				DisposHandle((Handle) (mem))
#define hrealloc(mem, size)	SetHandleSize((Handle) (mem), (size))
#define hsize(mem)				GetHandleSize((Handle) (mem))

Boolean validhandle(Handle hndl);
short checkhandle(Handle hndl);
HandleKey hlock(Handle hndl, Boolean move);
void hunlock(Handle hndl, HandleKey key);

#define _isspace(c)	((c)==' ' || (c)=='\t' || (c)=='\n' || (c)=='\r')
#define _isdigit(c)	('0' <= (c) && (c) <= '9')
#define _islower(c)	('a' <= (c) && (c) <= 'z')
#define _isupper(c)	('A' <= (c) && (c) <= 'Z')
#define _toupper(c)	((c) - 'a' + 'A')
#define _tolower(c)	((c) - 'A' + 'a')
#define MIN(x,y)		((x) < (y) ? (x) : (y))
#define MAX(x,y)		((x) > (y) ? (x) : (y))

void myassert(char *expr, char *file, int lnum);

#if ASSERTIONS
	#define assert(x)	((void) ((x) || (myassert(#x, __FILE__, __LINE__), 0)))
#else
	#define assert(x)	((void) 0)
#endif

#endif
