/*
Copyright  1990 Ari I. Halberstadt

This file is part of a free program. For precise terms of distribution
and use please see the files in the folder Legal accompanying this
software. If you make any modifications to this file you must add the
date, your name, and a description of what you have done to the
revision history below. This notice and the copyright notice must
remain intact in all copies of this file. The files in the folder
Legal must be available to anyone receiving copies of this file.

Add initials and name here:
Initials	Name
AIH		Ari I. Halberstadt

Revision History (date format is mm-dd-yy):
Date      Name  Comments
07-11-90	 AIH   Version 0.9
*/

#ifndef _H_stdconfig
#define _H_stdconfig

/*
	Conditional compilation and configuration flags.
	These are default values which can be overriden by placing
	defines in the file "privateconfig.h". To configure each
	prohect separately, place the file in a folder whose name
	is the same as the name of the project for which the
	configuration is intended. For instance, if the project is
	named "MyProject", then put the file "privateconfig.h"
	into the folder "(MyProject)".
*/

#include "privateconfig.h"

#ifndef DEBUG
	#define DEBUG			(1)	/* turns on various debugging code */
#endif

#ifndef ASSERTIONS
	#define ASSERTIONS	(1)	/* turns on assertions */
#endif

#ifndef ASSEMBLY
	#define ASSEMBLY		(1)	/* uses assembly language where provided */
										/* you want this option to be off if
											compiling with the profile option! */
#endif

#ifndef MPW
	#define MPW				(0)	/* using MPW */
#endif

#ifndef ANSI
	#define ANSI			(1)	/* define as 1 if we've got ANSI lib */
#endif

#ifndef APPLICATION
	#define APPLICATION	(1)	/* compiling as an application */
#endif

#ifndef CODE_RESOURCE
	#define CODE_RESOURCE (0)	/* compiling as a code resource */
#endif

#ifndef CUSTUM_HEADER
	#define CUSTOM_HEADER (0)	/* using THINK C's custom header */
#endif

#ifndef DRIVER
	#define DRIVER			(0)	/* compiling as a driver */
#endif

#if ! (ASSERTIONS) && ! (defined NDEBUG)
#define NDEBUG
#endif

#endif