/*
Copyright  1990 Ari I. Halberstadt

This file is part of a free program. For precise terms of distribution
and use please see the files in the folder Legal accompanying this
software. If you make any modifications to this file you must add the
date, your name, and a description of what you have done to the
revision history below. This notice and the copyright notice must
remain intact in all copies of this file. The files in the folder
Legal must be available to anyone receiving copies of this file.

Add initials and name here:
Initials	Name
AIH		Ari I. Halberstadt

Revision History (date format is mm-dd-yy):
Date      Name  Comments
07-11-90	 AIH   Version 0.9
*/

#include <MyHeaders>
#include "worldlib.h"

/*
	Functions for finding out if WaitNextEvent is available.
	From TN #158.
*/

#if THINK_C
typedef int TrapType;
#endif

static Boolean TrapAvailable(short num, TrapType type);

Boolean WNEIsImplemented(void)
{
	/* define trap number for old MPW or non-MPW C */
	#ifndef _WaitNextEvent
	#define _WaitNextEvent 0xA860
	#endif
	SysEnvRec world;
	SysEnvirons(1, &world);
	/* Even if we got an error from SysEnvirons, the
		SysEnvirons glue has set up machineType. */
	if (world.machineType < 0)
		return(false);
	else
		return(TrapAvailable(_WaitNextEvent, ToolTrap));
}

static Boolean TrapAvailable(short num, TrapType type)
{
	/* define trap number for old MPW or non-MPW C */
	#ifndef _Unimplemented
	#define _Unimplemented 0xA89F
	#endif
	
	/* Check and see if the trap exists. */
	/* On 64K ROM machines, type will be ignored. */
	
	return(NGetTrapAddress(num, type) != GetTrapAddress(_Unimplemented));
}
