/*
Copyright  1990 Ari I. Halberstadt

This file is part of a free program. For precise terms of distribution
and use please see the files in the folder Legal accompanying this
software. If you make any modifications to this file you must add the
date, your name, and a description of what you have done to the
revision history below. This notice and the copyright notice must
remain intact in all copies of this file. The files in the folder
Legal must be available to anyone receiving copies of this file.

Add initials and name here:
Initials	Name
AIH		Ari I. Halberstadt

Revision History (date format is mm-dd-yy):
Date      Name  Comments
07-11-90	 AIH   Version 0.9
*/

/*
	Definitions of all of the TABL resources for the ErrorString
	XFCN. These data are compiled into actual resources by the
	MakeRsrcs project.
*/

#include <MyHeaders>
#include "MakeRsrcs.h"
#include "Error.h"
#include "errorlib.h"

TablRsrcType error_strings[1] = {
	0, 0, NUMFLD,
	{
		{ ERR_BASIC_UNKNOWN,		"Unknown error" },
		{ ERR_BASIC_PROGRAM,		"Program error" },
		{ ERR_BASIC_ROMVER,		"Wrong version of ROM" },
		{ ERR_BASIC_SYSVER,		"Wrong version of System" },
		{ ERR_BASIC_HCVER,		"Wrong version of HyperCard" },
		{ ERR_BASIC_HYPERCARD,	"HyperCard error" },
		{ ERR_BASIC_ARGCNT,		"Wrong number of parameters" },
		{ ERR_BASIC_USAGE,		"Incorrect parameter usage" },
		{ ERR_BASIC_COMMAND,		"Unknown command" },
		{ ERR_BASIC_NOTIMPLEMENTED,"Unimplemented command" },
		{ ERR_BASIC_CANCELED,	"Operation was canceled" },
	
		{ ERR_STRLIST_INDEX,		"Subscript out of bounds" },
		{ ERR_STRLIST_NEGCNT,	"Negative count" },
		{ ERR_STRLIST_EMPTY,		"Empty array" },
		{ ERR_STRLIST_ATTR,		"Unknown attribute" },
	
		{ ERR_LTABLE_EXISTS,		"Array already exists" },
		{ ERR_LTABLE_NOTFOUND, 	"Array doesn't exist" },

		{ ERR_ARRAY_SUBSCRIPT,	"Illegal subscript" },

		{ ERR_ALST_CHKSUM,		"ArrayList checksum error" },
	
		{ ERR_PAT_EOF,				"Pattern ended unexpectedly" },
		{ ERR_PAT_LITERAL,		"Missing literal in pattern" },
		{ ERR_PAT_DIGIT,			"Missing digit in pattern" },
		{ ERR_PAT_ENDTAG,			"Missing \"\\)\" in pattern" },
		{ ERR_PAT_ECCL,			"Missing \"]\" in pattern" },
		{ ERR_PAT_EGROUP,			"Missing \")\" in pattern" },
		{ ERR_PAT_MAXTAG,			"Too many tags in pattern" },
		{ ERR_PAT_SIZE,			"Pattern is too big" },
		{ ERR_PAT_ENDCLOSURE,	"Missing \"}\" in pattern" },
		{ ERR_PAT_MAXMIN,			"Closure's min is greater than max" },
		{ ERR_PAT_MATCH,			"Pattern is too complex for input" },

		{ ERR_SRCH_OPTION,		"Unknown option" },
		{ ERR_SRCH_CHKSUM,		"Research checksum error" },
	
		{ ERR_STRTREE_EXISTS,	"Key already exists" },
		{ ERR_STRTREE_NOTFOUND,	"Key doesn't exist" },
		{ ERR_STRTREE_ATTR,		"Unknown attribute" },
		{ ERR_STRTREE_EMPTYKEY,	"Empty key" },

		{ ERR_FOREST_EXISTS,		"Tree already exists" },
		{ ERR_FOREST_NOTFOUND,	"Tree doesn't exist" },
	
		{ ERR_TREE_CHKSUM,		"BinaryTree checksum error" },
		{ 0, 0 },
	}
};

/* list of resources to compile */
TablListType error_string_tabls[5] = {
	{ ERRORNAME_XFCN_ID + RSRC_STRINGS_ID,
			ERRORSTRING_XFCN_NAME ":Strings", error_strings, },
	{ 0, 0, 0 },
};

