/*
Copyright  1990 Ari I. Halberstadt

This file is part of a free program. For precise terms of distribution
and use please see the files in the folder Legal accompanying this
software. If you make any modifications to this file you must add the
date, your name, and a description of what you have done to the
revision history below. This notice and the copyright notice must
remain intact in all copies of this file. The files in the folder
Legal must be available to anyone receiving copies of this file.

Add initials and name here:
Initials	Name
AIH		Ari I. Halberstadt

Revision History (date format is mm-dd-yy):
Date      Name  Comments
07-11-90	 AIH   Version 0.9
*/

/*
	Definitions of all of the TABL resources for the Research XFCN.
	These data are compiled into actual resources by the MakeRsrcs
	project.
*/

#include <MyHeaders>
#include "MakeRsrcs.h"
#include "RsrchMain.h"

TablRsrcType rsrch_commands[1] = {
	0, 0, STRFLD,
	{
		{ COMMAND_VERSION,	"!" },
		{ COMMAND_USAGE,		"?" },
		{ COMMAND_ERROR,		"Error" },
		{ COMMAND_MATCHED,	"Matched" },
		{ 0, 0 },
	}
};

TablRsrcType rsrch_options[1] = {
	0, 0, STRFLD,
	{
		{ OPTION_CHUNK,		"Chunk" },
		{ OPTION_GLOBAL,		"Global" },

		{ OPTION_FIRST,		"First" },
		{ OPTION_MATCH,		"Match" },

		{ OPTION_COUNT,		"Count" },
		{ OPTION_NUMBER,		"Number" },
		{ OPTION_INVERT,		"Invert" },
		{ OPTION_IGNRCASE,	"IgnoreCase" },
		
		{ OPTION_LIST,			"List" },
		{ OPTION_CONTAINERS,	"Containers" },
		{ OPTION_MPWMETA,		"MPWMeta" },
		{ OPTION_NOMETA,		"NoMeta" },
		{ OPTION_UNIXMETA,	"UnixMeta" },
		
		{ OPTION_SEPARATOR,	"Separator" },

		{ OPTION_FIRST_CARD,			"FirstCard" },
		{ OPTION_LAST_CARD,			"LastCard" },
		{ OPTION_START_CARD,			"StartCard" },
		{ OPTION_START_CHAR,			"StartCharacter" },
		{ OPTION_START_CONTAINER,	"StartContainer" },

		{ OPTION_NOPERIODIC,			"NoPeriodic" },
		{ OPTION_NOCANCEL,			"NoUserCancel" },
		{ OPTION_NOSPIN,				"NoBusyCursor" },
		
		{ 0, 0 }
	}
};

/* list of TABL resources to compile */
TablListType rsrch_tabls[5] = {

	{ RESEARCH_XFCN_ID + RSRC_COMMANDS_ID,
			RESEARCH_XFCN_NAME ":Functions", rsrch_commands },

	{ RESEARCH_XFCN_ID + RSRC_OPTIONS_ID,
			RESEARCH_XFCN_NAME ":Options", rsrch_options },

	{ 0, 0, 0 },
};
