/*
Copyright  1990 Ari I. Halberstadt

This file is part of a free program. For precise terms of distribution
and use please see the files in the folder Legal accompanying this
software. If you make any modifications to this file you must add the
date, your name, and a description of what you have done to the
revision history below. This notice and the copyright notice must
remain intact in all copies of this file. The files in the folder
Legal must be available to anyone receiving copies of this file.

Add initials and name here:
Initials	Name
AIH		Ari I. Halberstadt

Revision History (date format is mm-dd-yy):
Date      Name  Comments
07-11-90	 AIH   Version 0.9
*/

/*
	Interface functions between HyperCard's parameters and execution
	of the functions.
*/

#include <MyHeaders>
#include "RsrchMain.h"
#include "strlib.h"

/*----------------------------------------------------------------*/
/* Getting info about XFCN */
/*----------------------------------------------------------------*/

OSErr ExecUsage(GlobalData gdata, short arg)
{
	CStr255 str;
	GetIndString(str, GetRsrcID(gdata, RSRC_INFO_ID), RSRC_USAGE_INDEX);
	result2string(GetParam(gdata), PtoCstr(str));
	return(noErr);
}

OSErr ExecVersion(GlobalData gdata, short arg)
{
	CStr255	str;
	GetVerString(str, GetRsrcID(gdata, RSRC_INFO_ID), RSRC_VERSION_INDEX,
					__DATE__, __TIME__);
	result2string(GetParam(gdata), str);
	return(noErr);
}

/*----------------------------------------------------------------*/
/* Checking for errors */
/*----------------------------------------------------------------*/

OSErr ExecError(GlobalData gdata, short arg)
{
	return(GetError(gdata));
}

/*----------------------------------------------------------------*/
/* Finding out if last search matched something */
/*----------------------------------------------------------------*/

OSErr ExecMatched(GlobalData gdata, short arg)
{
	result2bool(GetParam(gdata), GetMatched(gdata));
	return(noErr);
}

