/*
Copyright  1990 Ari I. Halberstadt

This file is part of a free program. For precise terms of distribution
and use please see the files in the folder Legal accompanying this
software. If you make any modifications to this file you must add the
date, your name, and a description of what you have done to the
revision history below. This notice and the copyright notice must
remain intact in all copies of this file. The files in the folder
Legal must be available to anyone receiving copies of this file.

Add initials and name here:
Initials	Name
AIH		Ari I. Halberstadt

Revision History (date format is mm-dd-yy):
Date      Name  Comments
07-11-90	 AIH   Version 0.9
*/

/*
	This file contains functions which are part of the set of
	functions used to search for strings in a HyperCard string
	or container.
	
	These are several utility functions used when searching.
*/

#include <MyHeaders>
#include "search_private.h"

/* returns number of current card minus 1 (so that card numbers go
	from 0 to the number of cards in the stack minus 1) */
size_t _current_card_num(XCmdBlockPtr param)
{
	Handle str;
	size_t num;
	
	str = EvalExpr(param, (StrPtr) "\p number(this card)");
	if (str) {
		(void) hlock(str, false);
		num = atol(*str);
		num = num > 0 ? num-1 : 0;
		hfree(str);
	}
	else
		num = 0;
	return(num);
}

/* returns number of cards in stack */
size_t _cards_in_stack(XCmdBlockPtr param)
{
	Handle str;
	size_t num;
	
	str = EvalExpr(param, (StrPtr) "\p number(cards)");
	if (str) {
		(void) hlock(str, false);
		num = atol(*str);
		hfree(str);
	}
	else
		num = 0;
	return(num);
}

